-- Chapter03 Persistence Examples

DROP TABLE CH03_CUSTOMER_ORDER;
DROP TABLE CH03_CUSTOMER_ORDER_ID_GEN;
DROP TABLE CH03_CUSTOMER;
DROP TABLE CH03_CUSTOMER_ID_GEN;
DROP TABLE CH03_ADDRESS;
DROP TABLE CH03_ADDRESS_ID_GEN;

CREATE TABLE CH03_ADDRESS (
ID INTEGER PRIMARY KEY,
VERSION INTEGER,
STREET1 VARCHAR(4000),
STREET2 VARCHAR(4000),
CITY VARCHAR(4000),
STATE CHAR(2),
ZIP_CODE INTEGER);

CREATE TABLE "CH03_ADDRESS_ID_GEN" ("PRIMARY_KEY_NAME" VARCHAR(4000) PRIMARY KEY, "NEXT_ID_VALUE" INTEGER);
INSERT INTO "CH03_ADDRESS_ID_GEN" VALUES ('Address.id', 0);

CREATE TABLE CH03_CUSTOMER (
ID INTEGER PRIMARY KEY,
VERSION INTEGER,
SHIPPING_ADDRESS INTEGER REFERENCES CH03_ADDRESS(ID),
EMAIL VARCHAR(4000),
BILLING_ADDRESS INTEGER REFERENCES CH03_ADDRESS(ID));

CREATE TABLE "CH03_CUSTOMER_ID_GEN" ("PRIMARY_KEY_NAME" VARCHAR(4000) PRIMARY KEY, "NEXT_ID_VALUE" INTEGER);
INSERT INTO "CH03_CUSTOMER_ID_GEN" VALUES ('Customer.id', 0);

CREATE TABLE CH03_CUSTOMER_ORDER (
ID INTEGER PRIMARY KEY,
VERSION INTEGER,
CUSTOMER_ID INTEGER NOT NULL REFERENCES CH03_CUSTOMER(ID),
CREATION_DATE DATE,
STATUS VARCHAR(30));

CREATE TABLE "CH03_CUSTOMER_ORDER_ID_GEN" ("PRIMARY_KEY_NAME" VARCHAR(4000) PRIMARY KEY, "NEXT_ID_VALUE" INTEGER);
INSERT INTO "CH03_CUSTOMER_ORDER_ID_GEN" VALUES ('CustomerOrder.id', 0);